Unit afp8e_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure afp8e(var A :Array of Extended; N :Integer; M :Integer); 
implementation

procedure afp8e(var A :Array of Extended; N :Integer; M :Integer);
var
I,J,K,L :Integer;
R1,R2,R,P,T,C,S,A1,A2 :Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8;
begin
for K:=1 to M do
 begin
  L := K+1;
  if ( L > N ) 
   then goto _8;
  for I:=L to N do
   begin
    R2 := A[(I-1)+(K-1)*N];
    if ( R2 = 0.e0 ) 
     then goto _7;
    R1 := A[(K-1)+(K-1)*N];
    A1 := Abs(R1);
    A2 := Abs(R2);
    if ( A1 <> 0.e0 ) 
     then goto _1;
    T := 1.e0;
    A[(K-1)+(K-1)*N] := -A[(I-1)+(K-1)*N];
    goto _5;
_1:
    if ( A1 <= A2 ) 
     then goto _2;
    P := -R2/R1;
    R := Sqrt(1.e0+P*P);
    T := P/(R+1.e0);
    A[(K-1)+(K-1)*N] := R1*R;
    goto _5;
_2:
    P := -R1/R2;
    R := Sqrt(1.e0+P*P);
    T := 1.e0/(R+Abs(P));
    if ( P < 0.e0 ) 
     then T := -T;
    if ( R1 ) < 0
     then goto _3
     else if ( R1 ) > 0
           then goto _4
           else goto _4;
_3:
    A[(K-1)+(K-1)*N] := -A2*R;
    goto _5;
_4:
    A[(K-1)+(K-1)*N] := A2*R;
_5:
    A[(I-1)+(K-1)*N] := T;
    R := T*T;
    R1 := 1.e0/(1.e0+R);
    C := (1.e0-R)*R1;
    S := (T+T)*R1;
    if ( L > M ) 
     then goto _7;
    for J:=L to M do
     begin
      R1 := A[(K-1)+(J-1)*N];
      R2 := A[(I-1)+(J-1)*N];
      A[(K-1)+(J-1)*N] := C*R1-S*R2;
      A[(I-1)+(J-1)*N] := S*R1+C*R2;
_6:
     end;
_7:
   end;
_8:
 end;
end;

end.
